<script setup lang="ts">
import Select from '@/components/Select.vue';
import DatePicker from '@/components/DatePicker.vue';

import { onMounted, ref, watch } from 'vue';
import { selectedUid, fetchUid, itemsUid, itemsUp3 } from './reference';

const uidPlaceholder = 'Semua Unit Induk Distribusi/Wilayah'
const uppPlaceholder = 'Semua Unit Pelaksanaan Pelayanan Pelanggan'
const poskoPlaceholder = 'Semua Posko'
const uppp = ref({ id: 0, name: uppPlaceholder })
const uid = ref({ id: 0, name: uidPlaceholder })
const posko = ref({ id: 0, name: poskoPlaceholder })
const emit = defineEmits(['update:filters'])
const data = ref({
  uid: uid.value,
  up3: uppp.value,
  posko: posko.value,
  periode: ''
})

watch(data.value, (value) => {
  emit('update:filters', value)
})

const setUid = (value: any) => {
  uid.value = value
  selectedUid(value)
  uppp.value = { id: 0, name: uppPlaceholder }
  data.value.uid = value
}

const setUp3 = (value: any) => {
  uppp.value = value
  data.value.up3 = value
}

onMounted(() => {
  emit('update:filters', data.value)
  fetchUid()
})
</script>

<template>
  <div class="grid grid-cols-1 gap-4 md:grid-cols-2">
    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Induk Distribusi/Wilayah:</label>

      <Select @update:selected="setUid($event)" :data="itemsUid" :placeholder="uidPlaceholder" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Pelaksanaan Pelayanan Pelanggan:</label>

      <Select @update:selected="setUp3($event)" :data="itemsUp3" :selected="uppp" :placeholder="uppPlaceholder" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Periode Tanggal:</label>

      <DatePicker @update:date-value="(value) => (data.periode = value)" />
    </div>
  </div>

</template>
